#include <algorithm>
#include <cstdio>

#define MAX_SIZE (50000)

static long X[MAX_SIZE], Y[MAX_SIZE], Z[MAX_SIZE]; static long I[MAX_SIZE]; static long num;

inline long dis(long i1, long i2) { return std::abs(X[i1] - X[i2]) + std::abs(Y[i1] - Y[i2]) + std::abs(Z[i1] - Z[i2]); }

long get_min_dis(long IND[], long num, int dim) {
	long dmin = - 1;
	for (long i = 0; i < num; ++ i) for (long j = i + 1; j < num; ++ j) {
		long d = dis(IND[i], IND[j]);
		if ((dmin < 0) || (dmin > d)) dmin = d;
	}
	return dmin;
}

int main() {
	FILE *fid = fopen("input.txt", "rt"); fscanf(fid, "%li", &num);
	for (long i = 0; i < num; ++ i) {
		fscanf(fid, "%li %li %li", &X[i], &Y[i], &Z[i]);
		I[i] = i;
	}
	fclose(fid);
	//...
	long ans = (get_min_dis(I, num, 3) + 1) / 2;
	//...
	fid = fopen("output.txt", "wt");
	fprintf(fid, "%li\n", ans);
	fclose(fid);
	//...
	return 0;
}
